diff --git a/game/core/src/main/java/net/minecraft/core/world/generate/chunk/skyblock/ChunkDecoratorSkyblock.java b/game/core/src/main/java/net/minecraft/core/world/generate/chunk/skyblock/ChunkDecoratorSkyblock.java
index 8ff58e0fb..28d803342 100644
--- a/game/core/src/main/java/net/minecraft/core/world/generate/chunk/skyblock/ChunkDecoratorSkyblock.java
+++ b/game/core/src/main/java/net/minecraft/core/world/generate/chunk/skyblock/ChunkDecoratorSkyblock.java
@@ -21,7 +21,7 @@ public class ChunkDecoratorSkyblock
         }
         if (contains(chunk, 4, -3)) {
             chunk.setBlockIDWithMetadata(4 & (Chunk.CHUNK_SIZE_X - 1), 67, -3 & (Chunk.CHUNK_SIZE_Z - 1), Blocks.CHEST_PLANKS_OAK.id(), 3);
-            TileEntity tileEntity = chunk.getBlockEntity(4 & (Chunk.CHUNK_SIZE_X - 1), 67, -3 & (Chunk.CHUNK_SIZE_Z - 1));
+            TileEntity tileEntity = chunk.getTileEntity(4 & (Chunk.CHUNK_SIZE_X - 1), 67, -3 & (Chunk.CHUNK_SIZE_Z - 1));
             if (tileEntity instanceof TileEntityChest) {
                 TileEntityChest chestEntity = (TileEntityChest) tileEntity;
                 chestEntity.setItem(0, new ItemStack(Items.BUCKET_LAVA, 1));
@@ -32,7 +32,7 @@ public class ChunkDecoratorSkyblock
         // Desert island
         if (contains(chunk, -67, 0)) {
             chunk.setBlockIDWithMetadata(-67 & (Chunk.CHUNK_SIZE_X - 1), 67, 0 & (Chunk.CHUNK_SIZE_Z - 1), Blocks.CHEST_PLANKS_OAK.id(), 1);
-            TileEntity tileEntity = chunk.getBlockEntity(-67 & (Chunk.CHUNK_SIZE_X - 1), 67, 0 & (Chunk.CHUNK_SIZE_Z - 1));
+            TileEntity tileEntity = chunk.getTileEntity(-67 & (Chunk.CHUNK_SIZE_X - 1), 67, 0 & (Chunk.CHUNK_SIZE_Z - 1));
             if (tileEntity instanceof TileEntityChest) {
                 TileEntityChest chestEntity = (TileEntityChest) tileEntity;
                 chestEntity.setItem(0, new ItemStack(Blocks.OBSIDIAN, 14));
diff --git a/game/core/src/main/java/net/minecraft/core/world/generate/chunk/skyblock/ChunkDecoratorSkyblockNether.java b/game/core/src/main/java/net/minecraft/core/world/generate/chunk/skyblock/ChunkDecoratorSkyblockNether.java
index a457e4a81..465c27272 100644
--- a/game/core/src/main/java/net/minecraft/core/world/generate/chunk/skyblock/ChunkDecoratorSkyblockNether.java
+++ b/game/core/src/main/java/net/minecraft/core/world/generate/chunk/skyblock/ChunkDecoratorSkyblockNether.java
@@ -24,7 +24,7 @@ public class ChunkDecoratorSkyblockNether
         // Chest
         if (contains(chunk, 1, -1)) {
             chunk.setBlockIDWithMetadata(1 & (Chunk.CHUNK_SIZE_X - 1), 66, -1 & (Chunk.CHUNK_SIZE_Z - 1), Blocks.CHEST_PLANKS_OAK.id(), 3);
-            TileEntity tileEntity = chunk.getBlockEntity(1 & (Chunk.CHUNK_SIZE_X - 1), 66, -1 & (Chunk.CHUNK_SIZE_Z - 1));
+            TileEntity tileEntity = chunk.getTileEntity(1 & (Chunk.CHUNK_SIZE_X - 1), 66, -1 & (Chunk.CHUNK_SIZE_Z - 1));
             if (tileEntity != null) {
                 TileEntityChest tileEntityChest = (TileEntityChest) tileEntity;
                 tileEntityChest.setItem(0, new ItemStack(Blocks.SAPLING_BIRCH, 1));
diff --git a/game/core/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureDungeon.java b/game/core/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureDungeon.java
index 9f665a455..4c7dcd01f 100644
--- a/game/core/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureDungeon.java
+++ b/game/core/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureDungeon.java
@@ -157,7 +157,7 @@ public class WorldFeatureDungeon extends WorldFeature
                 }
                 world.setBlockWithNotify(k3, l3, i4, Blocks.CHEST_PLANKS_OAK.id());
                 BlockLogicChest.setDefaultDirection(world, k3, l3, i4);
-                TileEntityChest tileentitychest = (TileEntityChest)world.getBlockEntity(k3, l3, i4);
+                TileEntityChest tileentitychest = (TileEntityChest)world.getTileEntity(k3, l3, i4);
                 int k4 = 0;
                 do
                 {
@@ -177,7 +177,7 @@ public class WorldFeatureDungeon extends WorldFeature
         }
 
         world.setBlockWithNotify(x, y, z, Blocks.MOBSPAWNER.id());
-        TileEntityMobSpawner tileentitymobspawner = (TileEntityMobSpawner)world.getBlockEntity(x, y, z);
+        TileEntityMobSpawner tileentitymobspawner = (TileEntityMobSpawner)world.getTileEntity(x, y, z);
         tileentitymobspawner.setMobId(pickMobSpawner(random));
         return true;
     }
diff --git a/game/core/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureLabyrinth.java b/game/core/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureLabyrinth.java
index 7fedd3a98..407b76883 100644
--- a/game/core/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureLabyrinth.java
+++ b/game/core/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureLabyrinth.java
@@ -7,7 +7,10 @@ import net.minecraft.core.block.BlockLogicRotatable;
 import net.minecraft.core.block.entity.TileEntityChest;
 import net.minecraft.core.block.entity.TileEntityDispenser;
 import net.minecraft.core.block.entity.TileEntityMobSpawner;
+import net.minecraft.core.block.entity.TileEntityStatue;
 import net.minecraft.core.block.tag.BlockTags;
+import net.minecraft.core.enums.HumanArmorShape;
+import net.minecraft.core.item.IArmorItem;
 import net.minecraft.core.item.Item;
 import net.minecraft.core.item.Items;
 import net.minecraft.core.item.ItemStack;
@@ -16,14 +19,12 @@ import net.minecraft.core.world.biome.Biome;
 import net.minecraft.core.block.Blocks;
 import net.minecraft.core.block.material.Material;
 import net.minecraft.core.world.biome.Biomes;
+import org.jetbrains.annotations.Nullable;
 
 import java.util.Random;
 
 public class WorldFeatureLabyrinth extends WorldFeature
 {
-    public WorldFeatureLabyrinth()
-    {
-    }
     int dungeonSize = 0;
     int dungeonLimit;
     int dungeonCount = 0;
@@ -39,6 +40,14 @@ public class WorldFeatureLabyrinth extends WorldFeature
     public WeightedRandomBag<WeightedRandomLootObject> chestLoot;
     public WeightedRandomBag<WeightedRandomLootObject> dispenserLoot;
     public WeightedRandomBag<String> spawnerMonsters;
+
+    private int @Nullable[] platformPos = null;
+    private int @Nullable[] lastDungeon = null;
+
+    public WorldFeatureLabyrinth()
+    {
+    }
+
     @Override
     public boolean place(World world, Random random, int x, int y, int z)
     {
@@ -112,6 +121,12 @@ public class WorldFeatureLabyrinth extends WorldFeature
         if(canReplace(world, x, y, z)) {
             dungeonLimit = 1;
             generateBranch(world, random, x, y, z);
+            if (!treasureGenerated && lastDungeon != null) {
+                generateTrophyRoom(world, random, lastDungeon[1], lastDungeon[2], lastDungeon[3], lastDungeon[0]);
+            }
+            if (platformPos != null) {
+                generateStatue(world, platformPos[0], platformPos[1], platformPos[2], platformPos[3]);
+            }
             return true;
         }
         return false;
@@ -146,7 +161,7 @@ public class WorldFeatureLabyrinth extends WorldFeature
                                 BlockLogicRotatable.setDefaultDirection(world, x, y, z);
                                 world.setBlockWithNotify(x, y - 1, z, Blocks.DISPENSER_COBBLE_STONE.id());
                                 BlockLogicRotatable.setDefaultDirection(world, x, y - 1, z);
-                                TileEntityDispenser tileEntityDispenser = (TileEntityDispenser) world.getBlockEntity(x, blockY - 1, z);
+                                TileEntityDispenser tileEntityDispenser = (TileEntityDispenser) world.getTileEntity(x, blockY - 1, z);
                                 int k4 = 0;
                                 while (k4 < 3) {
                                     ItemStack itemstack = pickDispenserLootItem(random);
@@ -314,7 +329,7 @@ public class WorldFeatureLabyrinth extends WorldFeature
             else
                 generateDrop(world, random, blockX, blockY, blockZ);
         }
-        else if(random.nextInt(2) == 0 && corridorIteration > 1 && dungeonSize > 3 || (dungeonSize >= 10 && dungeonCount<dungeonLimit)) {
+        else if(random.nextInt(2) == 0 && corridorIteration > 1 && dungeonSize > 3 || (dungeonSize >= 10 && dungeonCount < dungeonLimit)) {
             createDungeon(world, random, blockX, blockY, blockZ, rot);
             dungeonCount++;
         }
@@ -375,7 +390,7 @@ public class WorldFeatureLabyrinth extends WorldFeature
         if(canReplace(world, chestX, blockY-2, chestZ)) {
             world.setBlockWithNotify(chestX, blockY - 1, chestZ, Blocks.CHEST_PLANKS_OAK.id());
             BlockLogicChest.setDefaultDirection(world, chestX, blockY - 1, chestZ);
-            TileEntityChest tileentitychest = (TileEntityChest) world.getBlockEntity(chestX, blockY - 1, chestZ);
+            TileEntityChest tileentitychest = (TileEntityChest) world.getTileEntity(chestX, blockY - 1, chestZ);
             int k4 = 0;
             while (k4 < 10) {
                 ItemStack itemstack = pickCheckLootItem(random);
@@ -388,7 +403,7 @@ public class WorldFeatureLabyrinth extends WorldFeature
         if (doSpawner)
         {
             world.setBlockWithNotify(blockX, blockY-1, blockZ, Blocks.MOBSPAWNER.id());
-            TileEntityMobSpawner tileentitymobspawner = (TileEntityMobSpawner)world.getBlockEntity(blockX, blockY-1, blockZ);
+            TileEntityMobSpawner tileentitymobspawner = (TileEntityMobSpawner)world.getTileEntity(blockX, blockY-1, blockZ);
             if(tileentitymobspawner != null)
                 tileentitymobspawner.setMobId(pickMobSpawner(random));
         }
@@ -465,6 +480,103 @@ public class WorldFeatureLabyrinth extends WorldFeature
 
     }
 
+    private void generateTrophyRoom(World world, Random random, int blockX, int blockY, int blockZ, int rot) {
+        int size = 8;
+//        int sideFacing = random.nextInt(2);
+        if (blockY < 10)
+            return;
+        for (int x = blockX - size; x <= blockX + size; x++) {
+            for (int y = blockY - 2; y <= blockY + 6; y++) {
+                for (int z = blockZ - size; z <= blockZ + size; z++) {
+                    int xRoom = x - blockX + size;
+                    int zRoom = z - blockZ + size;
+                    boolean xWallCheck = x == blockX - size || x == blockX + size;
+                    boolean zWallCheck = z == blockZ - size || z == blockZ + size;
+                    boolean yWallCheck = y == blockY - 2;
+                    if (canReplace(world, x, y, z)) {
+                        if (xWallCheck) {
+                            if (zRoom % 4 != 0) {
+                                world.setBlockWithNotify(x, y, z, wallBlockB);
+                            } else world.setBlockWithNotify(x, y, z, brickBlockA);
+                        }
+                        else if (zWallCheck) {
+                            if (xRoom % 4 != 0) {
+                                world.setBlockWithNotify(x, y, z, wallBlockB);
+                            } else world.setBlockWithNotify(x, y, z, brickBlockA);
+                        }
+                        else if (yWallCheck) {
+                            if ((x > blockX - 2 && x < blockX + 2) || (z > blockZ - 2 && z < blockZ + 2))
+                                if (x == blockX || z == blockZ) {
+                                    world.setBlockWithNotify(x, y, z, isCold ? Blocks.OBSIDIAN.id() : Blocks.FLUID_LAVA_FLOWING.id());
+                                } else {
+                                    world.setBlockWithNotify(x, y, z, isCold ? Blocks.PERMAFROST_POLISHED.id() : Blocks.STONE_POLISHED.id());
+                                }
+                            else if (random.nextInt(5) == 0)
+                                world.setBlockWithNotify(x, y, z, wallBlockB);
+                            else
+                                world.setBlockWithNotify(x, y, z, wallBlockA);
+                            if (x > blockX - 3 && x < blockX + 3 && z > blockZ - 3 && z < blockZ + 3)
+                                world.setBlockWithNotify(x, y, z, wallBlockB);
+                        } else if (y == blockY + 6) {
+                            if (random.nextInt(5) == 0)
+                                world.setBlockWithNotify(x, y, z, wallBlockB);
+                            else
+                                world.setBlockWithNotify(x, y, z, wallBlockA);
+                        } else if (x > blockX - size && x < blockX + size || z > blockZ - size && z < blockX + size) {
+                                world.setBlockWithNotify(x, y, z, 0);
+                        } else
+                            world.setBlockWithNotify(x, y, z, 0);
+                        if (zRoom % 2 == 0
+                            && (x == blockX - 2 || x == blockX + 2)
+                            && (z == blockZ - 2 || z == blockZ + 2)) {
+                            world.setBlockWithNotify(x, y, z, brickBlockA);
+                        }
+                    }
+                }
+            }
+        }
+
+        platformPos = new int[] { rot, blockX, blockY, blockZ };
+    }
+
+    private void generateStatue(World world, int rot, int blockX, int blockY, int blockZ) {
+        for (int x = blockX - 1; x <= blockX + 1; x++) {
+            for (int z = blockZ - 1; z <= blockZ + 1; z++) {
+                if (x == blockX && z == blockZ) {
+                    world.setBlockAndMetadataWithNotify(x, blockY - 1, z, isCold ? Blocks.SLAB_PERMAFROST_POLISHED.id() : Blocks.SLAB_STONE_POLISHED.id(), 1);
+                } else {
+                    world.setBlockWithNotify(x, blockY - 1, z, isCold ? Blocks.SLAB_PERMAFROST_POLISHED.id() : Blocks.SLAB_STONE_POLISHED.id());
+                }
+            }
+        }
+
+        int meta = 0;
+        switch (rot) {
+            case 0:
+                meta = 8;
+                break;
+            case 1:
+                meta = 12;
+                break;
+            case 2:
+                meta = 0;
+                break;
+            case 3:
+                meta = 4;
+                break;
+        }
+        world.setBlockAndMetadata(blockX, blockY, blockZ, Blocks.STATUE_PIGMAN_LOWER.id(), meta);
+        world.setBlockAndMetadata(blockX, blockY + 1, blockZ, Blocks.STATUE_PIGMAN_UPPER.id(), meta);
+        TileEntityStatue statue = (TileEntityStatue) world.getTileEntity(blockX, blockY, blockZ);
+        Item treasureItem = this.treasureItem.getItem();
+        if (treasureItem instanceof IArmorItem && ((IArmorItem<?>) treasureItem).getArmorShape() instanceof HumanArmorShape) {
+            statue.setItemInArmorSlot(((IArmorItem<HumanArmorShape>) treasureItem).getArmorShape(), this.treasureItem.copy());
+        } else {
+            statue.setHeldItem(this.treasureItem.copy());
+        }
+        statue.setPose(TileEntityStatue.Pose.LOOK_UP);
+    }
+
     private void createDungeon(World world, Random random, int blockX, int blockY, int blockZ, int rot)
     {
         int dx = 0, dz = 0;
@@ -487,7 +599,12 @@ public class WorldFeatureLabyrinth extends WorldFeature
 
         if (canReplace(world, blockX + dx * 5, blockY, blockZ + dz * 5))
         {
-            if (dungeonSize==10 && !libraryGenerated)
+            if (!treasureGenerated && dungeonSize == 10)
+            {
+                treasureGenerated = true;
+                generateTrophyRoom(world, random, blockX + dx * 4, blockY, blockZ + dz * 4, rot);
+            }
+            else if (!libraryGenerated && random.nextInt(3) == 0)
             {
                 libraryGenerated = true;
                 generateLibrary(world, random, blockX + dx * 4, blockY, blockZ + dz * 4);
@@ -495,6 +612,7 @@ public class WorldFeatureLabyrinth extends WorldFeature
             else
             {
                 generateDungeon(world, random, blockX + dx * 4, blockY, blockZ + dz * 4, true);
+                lastDungeon = new int[] { rot, blockX + dx * 4, blockY, blockZ + dx * 4 };
             }
         }
 
@@ -507,11 +625,6 @@ public class WorldFeatureLabyrinth extends WorldFeature
 
     private ItemStack pickCheckLootItem(Random random)
     {
-        if(!treasureGenerated && dungeonSize > 7)
-        {
-            treasureGenerated = true;
-            return treasureItem.copy();
-        }
         return chestLoot.getRandom(random).getItemStack(random);
     }
 
diff --git a/game/core/src/main/java/net/minecraft/core/world/save/DimensionData.java b/game/core/src/main/java/net/minecraft/core/world/save/DimensionData.java
index 8bd87d572..9f2cd1e1d 100644
--- a/game/core/src/main/java/net/minecraft/core/world/save/DimensionData.java
+++ b/game/core/src/main/java/net/minecraft/core/world/save/DimensionData.java
@@ -150,7 +150,7 @@ public class DimensionData
         if (weather == null) {
             this.weatherCurrentId = -1;
         } else {
-            this.weatherCurrentId = weather.weatherId;
+            this.weatherCurrentId = weather.getId();
         }
     }
 
@@ -168,7 +168,7 @@ public class DimensionData
         }
         else
         {
-            this.weatherNextId = weather.weatherId;
+            this.weatherNextId = weather.getId();
         }
     }
 
diff --git a/game/core/src/main/java/net/minecraft/core/world/season/Season.java b/game/core/src/main/java/net/minecraft/core/world/season/Season.java
index a10430110..e05d357b8 100644
--- a/game/core/src/main/java/net/minecraft/core/world/season/Season.java
+++ b/game/core/src/main/java/net/minecraft/core/world/season/Season.java
@@ -43,7 +43,7 @@ public abstract class Season
 
 	public String getTranslatedName()
 	{
-		return I18n.getInstance().translateNameKey(languageKey);
+		return I18n.getInstance().translateKey(languageKey + ".name");
 	}
 	
 	public Season allowWeather(Weather weather, float probability)
diff --git a/game/core/src/main/java/net/minecraft/core/world/type/WorldTypeEmpty.java b/game/core/src/main/java/net/minecraft/core/world/type/WorldTypeEmpty.java
index be6be9932..5636a9aae 100644
--- a/game/core/src/main/java/net/minecraft/core/world/type/WorldTypeEmpty.java
+++ b/game/core/src/main/java/net/minecraft/core/world/type/WorldTypeEmpty.java
@@ -68,7 +68,7 @@ public class WorldTypeEmpty
         float weatherOffset = 0;
         Weather currentWeather = world.getCurrentWeather();
         if (currentWeather != null)
-            weatherOffset = currentWeather.subtractLightLevel * world.weatherManager.getWeatherIntensity() * world.weatherManager.getWeatherPower();
+            weatherOffset = currentWeather.getLightLevelSubtracted() * world.weatherManager.getWeatherIntensity() * world.weatherManager.getWeatherPower();
         return (int) (f2 * (11F - weatherOffset) + weatherOffset);
     }
 }
diff --git a/game/core/src/main/java/net/minecraft/core/world/type/WorldTypes.java b/game/core/src/main/java/net/minecraft/core/world/type/WorldTypes.java
index 4d6fe1dc5..294fb8285 100644
--- a/game/core/src/main/java/net/minecraft/core/world/type/WorldTypes.java
+++ b/game/core/src/main/java/net/minecraft/core/world/type/WorldTypes.java
@@ -113,14 +113,14 @@ public abstract class WorldTypes {
                             .fillerBlock(Blocks.STONE)
                             .allowRespawn()
                             .bounds(0, 127, 64)
-                            .defaultWeather(Weathers.OVERWORLD_CLEAR_HELL)
+                            .defaultWeather(Weathers.OVERWORLD_HELL_CLEAR)
             )
     );
     public static final WorldType OVERWORLD_WOODS = register(
             "minecraft:overworld.woods",
             new WorldTypeOverworldWoods(
                     WorldTypeOverworld.defaultProperties("worldType.overworld.woods")
-                            .defaultWeather(Weathers.OVERWORLD_CLEAR_WOODS)
+                            .defaultWeather(Weathers.OVERWORLD_WOODS_CLEAR)
             )
     );
     public static final WorldType OVERWORLD_PARADISE = register(
@@ -148,6 +148,7 @@ public abstract class WorldTypes {
                     WorldTypeOverworld.defaultProperties("worldType.overworld.classic")
                             .seasonConfig(null)
                             .bounds(0, 127, 64)
+                            .setRetro()
             )
     );
     public static final WorldType OVERWORLD_INDEV = register(
diff --git a/game/core/src/main/java/net/minecraft/core/world/type/overworld/WorldTypeOverworld.java b/game/core/src/main/java/net/minecraft/core/world/type/overworld/WorldTypeOverworld.java
index 02e75163f..cb7050017 100644
--- a/game/core/src/main/java/net/minecraft/core/world/type/overworld/WorldTypeOverworld.java
+++ b/game/core/src/main/java/net/minecraft/core/world/type/overworld/WorldTypeOverworld.java
@@ -84,7 +84,7 @@ public class WorldTypeOverworld
         float weatherOffset = 0;
         Weather currentWeather = world.getCurrentWeather();
         if (currentWeather != null)
-            weatherOffset = currentWeather.subtractLightLevel * world.weatherManager.getWeatherIntensity() * world.weatherManager.getWeatherPower();
+            weatherOffset = currentWeather.getLightLevelSubtracted() * world.weatherManager.getWeatherIntensity() * world.weatherManager.getWeatherPower();
         return (int) (f2 * (11F - weatherOffset) + weatherOffset);
     }
 }
diff --git a/game/core/src/main/java/net/minecraft/core/world/type/paradise/WorldTypeParadise.java b/game/core/src/main/java/net/minecraft/core/world/type/paradise/WorldTypeParadise.java
index d966edec0..72c0684a7 100644
--- a/game/core/src/main/java/net/minecraft/core/world/type/paradise/WorldTypeParadise.java
+++ b/game/core/src/main/java/net/minecraft/core/world/type/paradise/WorldTypeParadise.java
@@ -87,7 +87,7 @@ public class WorldTypeParadise
         }
         float weatherOffset = 0;
         if (world.getCurrentWeather() != null)
-            weatherOffset = world.getCurrentWeather().subtractLightLevel * world.weatherManager.getWeatherIntensity() * world.weatherManager.getWeatherPower();
+            weatherOffset = world.getCurrentWeather().getLightLevelSubtracted() * world.weatherManager.getWeatherIntensity() * world.weatherManager.getWeatherPower();
         int subtracted = (int) (f2 * (11F - weatherOffset) + weatherOffset);
         if (subtracted > 8) subtracted = 8;
         return subtracted;
diff --git a/game/core/src/main/java/net/minecraft/core/world/weather/IPrecipitation.java b/game/core/src/main/java/net/minecraft/core/world/weather/IPrecipitation.java
new file mode 100644
index 000000000..b0da6c58d
--- /dev/null
+++ b/game/core/src/main/java/net/minecraft/core/world/weather/IPrecipitation.java
@@ -0,0 +1,17 @@
+package net.minecraft.core.world.weather;
+
+import org.jetbrains.annotations.NotNull;
+
+public interface IPrecipitation {
+    enum Type {
+        RAIN_LIKE,
+        SNOW_LIKE,
+        INVERTED_RAIN_LIKE
+    }
+
+    @NotNull Type getPrecipitationType();
+
+    @NotNull String getPrecipitationTexturePath(final float power, final float intensity);
+
+    boolean spawnRainParticles();
+}
